Attribute VB_Name = "swf_Handling"
' module: swf - handling
' McT / 06.02.03
' checked ~ 1.1

Option Explicit

' *********************************************
' vars
' *********************************************

Private i&

' *********************************************
' removing
' *********************************************

Public Sub RemSymbols()
' *************
' -> macro call
' *************
    
    On Error GoTo errRemove
    
    RemNote
    RemSFS

    Exit Sub

errRemove:
    HandleError
    
End Sub

Public Sub RemNote()
' *************
' -> remove old note
' *************

    Dim ret As Boolean
    
    ' -> find element
    ret = drw.Extension.SelectByID(NoteID + "@" + sheetName, "NOTE", _
    0, 0, 0, False, 0, Nothing)
    ' -> delete note
    If ret Then drw.DeleteSelection True

End Sub

Public Sub RemSFS()
' *************
' -> insert old sfs
' *************
    
    Dim ret As Boolean
    
    For i = 0 To oldSFScount - 1
        ' -> delete sfs
        ret = oldSFS(i).GetAnnotation.Select2(False, 0)
        If ret Then drw.DeleteSelection True
    Next i

End Sub

' *********************************************
' inserting
' *********************************************

Public Sub InsertSymbols()
' *************
' -> macro call
' *************

    On Error GoTo errInsert
    
    ' -> insert symbols
    insertSFS
    If sfsCount > 0 Then InsertNote

    Exit Sub

errInsert:
    HandleError

End Sub

Private Sub HandleError()
' *************
' -> handle error
' *************
    
    GEF.Raise "Fehler beim Einfgen der Symbole !", swf_MainForm.Caption, swf_MainForm.Icon
    swf_MainForm.shutDown

End Sub

Public Sub insertSFS()
' *************
' -> insert sfs collection
' *************
    
    ' -> lock sheet
    sheetLockUsr = Not sw.GetUserPreferenceToggle(swDynamicDrawingViewActivation)
    sheetLockCur = True
    If Not sheetLockUsr Then sw.SetUserPreferenceToggle swDynamicDrawingViewActivation, False

    ' -> activate sheet
    drw.ActivateSheet sheetName
    
    ' -> inser SFS's
    For i = 0 To sfsCount
       ' -> insert
        createSFS sfsList(i)
    Next i
    
    ' -> unlock sheet
    If Not sheetLockUsr Then sw.SetUserPreferenceToggle swDynamicDrawingViewActivation, True

End Sub

Public Sub createSFS(newSFS As sfsObject)
' *************
' -> insert single sfs
' *************
    
    Dim newSFSPTR As Object
    
    ' -> select position
    drw.SelectByID sheetName, "SHEET", newSFS.x, newSFS.y, 0
    ' -> insert SFS
    drw.InsertSurfaceFinishSymbol2 newSFS.sfsType, 0, 0, 0, 0#, 0, 1, "", "", _
                                   newSFS.methodestr, "", newSFS.maxRoughStr, "", ""
    
    ' -> find object pointer
    Set view = drw.GetFirstView ' = sheet
    Set newSFSPTR = view.GetFirstSFSymbol
    If newSFSPTR Is Nothing Then Exit Sub ' no sfs on sheet - error

    ' -> go to last = created object
    While Not newSFSPTR.GetNext Is Nothing
        Set newSFSPTR = newSFSPTR.GetNext
    Wend
    
    ' -> set ID
    Dim ann As Object, font As Object
    
    Set ann = newSFSPTR.GetAnnotation
    
    ann.SetName SymbolID + Format(newSFS.id, "00")
    
    ' -> set Font
    If useDocFont = 0 Then
        Set font = ann.gettextformat(0)
        font.TypeFaceName = sFontName
        font.CharHeight = sFontSize / 4000
        ann.SetTextFormat 0, False, font
    End If
End Sub

Public Sub InsertNote()
' *************
' -> insert new note
' *************

    Dim note As Object
    
    ' -> select position
    drw.SelectByID sheetName, "SHEET", pN(x), pN(y), 0

    ' -> insert note
    Set note = drw.InsertNote(noteStr)

    ' -> format note
    If Not note Is Nothing Then
        
        ' -> text format
        Dim font As Object
        note.angle = 0
        note.SetBalloon 0, 0
        Set font = note.gettextformat
        font.TypeFaceName = bFontName
        font.CharHeightInPts = bFontSize
        font.Bold = False
        note.SetTextFormat 0, font
        
        ' -> ID
        note.GetAnnotation.SetName NoteID
    
    End If

End Sub

' *********************************************
' analyzing
' *********************************************

Public Sub AnalyzeDrawing()
' *************
' -> check drawing content
' *************

    Dim curSFS As Object, curName$, delSFS As Object
    
    Dim a&, b$, c$

    sfsCount = 0 ' start at 0
    oldSFScount = 0
    sfsList(0).id = 0
    
    ' -> analyze drawing
    Set view = drw.GetFirstView
        
    ' -> view loop
    While Not view Is Nothing
    
        Set curSFS = view.GetFirstSFSymbol

        While Not curSFS Is Nothing
            
     
            
            ' -> load sw data
            a = curSFS.GetSymbolType
            b = curSFS.GetText(swSFSymbolMaximumRoughness)
            c = curSFS.GetText(swSFSymbolProductionMethod)
            
            curName = curSFS.GetAnnotation.GetName

            If VBA.left(curName, SymbolID_Len) = SymbolID Then
                
                Set oldSFS(oldSFScount) = curSFS
                oldSFScount = oldSFScount + 1
                
                ' -> found drawing standard
                If VBA.right(curName, CounterID_Len) = StandardID Then
                    sfsList(0).id = StandardID
                    sfsList(0).sfsType = a
                    sfsList(0).maxRoughStr = b
                    sfsList(0).methodestr = c
                End If

            Else
                
                ' -> add, if not double
                If DoubleCheck(a, b, c) = -1 Then
                    sfsCount = sfsCount + 1
                    sfsList(sfsCount).id = sfsCount
                    sfsList(sfsCount).sfsType = a
                    sfsList(sfsCount).maxRoughStr = b
                    sfsList(sfsCount).methodestr = c
                End If

            End If
            
            ' ->  get next
            Set curSFS = curSFS.GetNext
        
        
        Wend
    
        ' -> next view
        Set view = view.GetNextView
    
    Wend

End Sub

Private Function DoubleCheck(a&, b$, c$) As Long
' *************
' -> sfs comparisation
' *************

    Dim b1 As Boolean, b2 As Boolean, b3 As Boolean
    DoubleCheck = -1
    For i = 1 To sfsCount
        ' -> comparisation matrix
        b1 = sfsList(i).sfsType = a
        b2 = sfsList(i).maxRoughStr = b
        b3 = sfsList(i).methodestr = c
        If (b1 And b2 And b3) Then DoubleCheck = i: Exit For
    Next i
  
End Function

Public Sub DoubleCheck2()
' *************
' -> sfs comparisation II
' *************

    ' -> double check II
    Dim p&
    p = DoubleCheck(sfsList(0).sfsType, sfsList(0).maxRoughStr, sfsList(0).methodestr)
    If p <> -1 Then
        For i = p To sfsCount - 1
            sfsList(i) = sfsList(i + 1)
        Next i
        sfsCount = sfsCount - 1
    End If

End Sub


' *********************************************
' sw access handling
' *********************************************

Public Function initSW() As Boolean
' *************
' -> access sw
' *************
    
    Dim errTxt$
    
    On Error Resume Next
   
    Set sw = GetObject(, "SldWorks.Application")
    If Err.Number = 0 Then
        Set drw = sw.ActiveDoc
        If Not drw Is Nothing Then
            If drw.GetType = swDocDRAWING Then
                Set view = drw.GetFirstView
                ' -> get sheetname
                sheetName = drw.GetCurrentSheet.GetName
                errTxt = ""
                initSW = True
            Else
                errTxt = "Es werden nur SolidWorks Zeichnungen untersttzt !"
            End If
        Else
            errTxt = "Kein SolidWorks Dokument geladen !"
        End If
    Else
        errTxt = "Keine aktive SolidWorks Instanz gefunden !"
    End If
    
    If errTxt <> "" Then
        
        initSW = False
        GEF.Raise errTxt, swf_MainForm.Caption, swf_MainForm.Icon
    
    End If
    
End Function
           
Public Sub freeSW()
' *************
' -> free sw access
' *************

    Set view = Nothing
    Set drw = Nothing
    Set sw = Nothing

End Sub


